cd('scripts/')
load('octmch_mchKey_flyNums.mat')
load('finalStorageOCTMCH.mat')

%% Compiling PCA lines into a matrix
fpca = [];cnt = 1;
for i = 1:length(finalStorage)
    for k = 1:length(finalStorage{i,4})
        fpca(cnt,:) = finalStorage{i,4}{2,k};
        cnt = cnt+1;
    end
end
%% Remove glomeruli
reUp = [];
glomsToInclude= [1:6,8:14,16];
for i = 0:16:length(fpca(1,:))-15
    temp = fpca(:,i+glomsToInclude);
    reUp(:,end+1:end+length(temp(1,:))) = temp;
end
fpca = reUp;
%% Replacing NaNs with mean values
tempF = [];
gloms = nanmean(fpca);
for i = 1:length(fpca(:,1))
    temp = find(isnan(fpca(i,:)));
    tempF(i,:) = fpca(i,:);
    for k = temp
        tempF(i,k) = gloms(k);
    end
end
fpca = tempF;
%% Z-score by glomerulus
pcaT = [];
glmLgth = length(glomsToInclude);
for i = 1:glmLgth
    glomTemp = i;
    glomTemp2 = fpca(:,glomTemp);
    glomMean = nanmean(glomTemp2(:));
    glomStd = nanstd(glomTemp2(:));
    pcaT(:,i) = (glomTemp2-glomMean)./glomStd;
end
fpca = pcaT;

%%
[coeff,score,latent,tsquared,explained,mu] = pca(fpca);
%% Special flies are: 3, 14, and 7 in total which translates to being flies 1, 8, and 3 of control set
%% Generate control animals
amwF = [];
for i = 1:length(flyNum)
    amwF(i) = amw(flyNum(i));
end
controlOut = score(~amwF,:);
flyNumC = flyNum(~amwF);
mchKeyC = mchKey(~amwF);
%% Generate list of control flys without repeating a number
listFlyNum = cell(1,max(flyNumC));
for i = 1:length(flyNumC)
    if mchKeyC(i)
        continue
    end
    listFlyNum{flyNumC(i)} = [listFlyNum{flyNumC(i)};controlOut(i,:)];
end
%%
pcaColorStore = rand(length(controlOut(:,1)),3);
%pcaColorStore = brewermap(14,'Set2');
figTime = figure;
cnt = 1;
indR = zeros(1,length(listFlyNum));indR([3,14,5]) = 1;indR = logical(indR);
reArg = listFlyNum(indR);lastFlies = listFlyNum(~indR);
listFlyNum = [reArg,lastFlies];
for i = length(listFlyNum):-1:1
    if isempty(listFlyNum{i})
        continue
    end
    c3 = 300;
    a2 = scatter(listFlyNum{i}(1,1),listFlyNum{i}(1,2));hold on;
    a2.MarkerFaceColor = pcaColorStore(cnt,:);
    a2.MarkerEdgeColor = [0 0 0];
    a2.MarkerFaceAlpha = 0.5;
    a2.SizeData = c3;
    if i == 1 | i == 2 | i == 3
       a2.MarkerEdgeColor = [0 0 0];
       a2.SizeData = 500;
       a2.LineWidth = 2;
       if i == 1
       a2.Marker = 'd';
       elseif i == 2
           a2.Marker = 'p';
       elseif i == 3
           a2.Marker = 's';
       end
       a2.MarkerFaceAlpha = 1;
    end
    cnt = cnt+1;
end
%%
flyName = {};
for i = 1:cnt-1
    flyName{i} = strcat({'fly '},num2str(i));
    flyName{i} = flyName{i}{1};
end
flyName = flyName(end:-1:1);

atLeg = legend(flyName);
atLeg.Box = 'off';
atLeg.AutoUpdate = 'off';
atLeg.Position = [0.2335    0.7048    0.0973    0.1893];
%%
cnt = 1;
for i = length(listFlyNum):-1:1
    if isempty(listFlyNum{i})
        continue
    end
    c3 = 300;
    a2 = scatter(listFlyNum{i}(2:end,1),listFlyNum{i}(2:end,2));hold on;
    a2.MarkerFaceColor = pcaColorStore(cnt,:);
    a2.MarkerEdgeColor = [0 0 0];
    a2.MarkerFaceAlpha = 0.5;
    a2.SizeData = c3;
    temp = listFlyNum{i};
    for ii = 1:length(temp(:,1))
        for iii = 1:length(temp(:,1))
            if ii ~= iii
            a3 = plot([temp(ii,1),temp(iii,1)],[temp(ii,2),temp(iii,2)]);
            a3.LineWidth = 2;a3.Color = pcaColorStore(cnt,:);
            end
        end
    end
    if i == 1 | i == 2 | i == 3
       a2.MarkerEdgeColor = [0 0 0];
       a2.SizeData = 500;
       a2.LineWidth = 2;
       if i == 1
       a2.Marker = 'd';
       elseif i == 2
           a2.Marker = 'p';
       elseif i == 3
           a2.Marker = 's';
       end
       a2.MarkerFaceAlpha = 1;
    end
    cnt = cnt+1;
end
%%
benFigureFormat_gen
pcaPercent = latent/sum(latent)*100;
a = xlabel(strcat('PC 1','(',num2str(round(pcaPercent(1),2)),'%',')'));a.Position(2) = a.Position(2)-0.15;
a = ylabel(strcat('PC 2','(',num2str(round(pcaPercent(2)),2),'%',')'));a.Position(1) = a.Position(1)-0.15;
title('Responses to octanol')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%% Find flies for MCH trials
for i = 1:length(flyNum)
    amwF(i) = amw(flyNum(i));
end
controlOut = score(~amwF,:);
flyNumC = flyNum(~amwF);
mchKeyC = mchKey(~amwF);
%% Annotate list of flies with MCH trials
listFlyNum = cell(1,max(flyNumC));
for i = 1:length(flyNumC)
    if ~mchKeyC(i)
        continue
    end
    listFlyNum{flyNumC(i)} = [listFlyNum{flyNumC(i)};controlOut(i,:)];
end
%%
figTime = figure;
cnt = 1;
indR = zeros(1,length(listFlyNum));indR([3,14,5]) = 1;indR = logical(indR);
reArg = listFlyNum(indR);lastFlies = listFlyNum(~indR);
listFlyNum = [reArg,lastFlies];

for i = length(listFlyNum):-1:1
    if isempty(listFlyNum{i})
        continue
    end
    c3 = 300;
    a2 = scatter(listFlyNum{i}(1,1),listFlyNum{i}(1,2));hold on;
    
    a2.MarkerFaceColor = pcaColorStore(cnt,:);
    a2.MarkerEdgeColor = [0 0 0];
    a2.MarkerFaceAlpha = 0.5;
    a2.SizeData = c3;
    if i == 1 | i == 2 | i == 3
       a2.MarkerEdgeColor = [0 0 0];
       a2.SizeData = 500;
       a2.LineWidth = 2;
       if i == 1
       a2.Marker = 'd';
       elseif i == 2
           a2.Marker = 'p';
       elseif i == 3
           a2.Marker = 's';
       end
       a2.MarkerFaceAlpha = 1;
    end
    cnt = cnt+1;
end
%%
flyName = {};
for i = cnt-1:-1:1
    flyName{i} = strcat({'fly '},num2str(i));
    flyName{i} = flyName{i}{1};
end
flyName = flyName(end:-1:1);
atLeg = legend(flyName);
atLeg.Box = 'off';
atLeg.AutoUpdate = 'off';
atLeg.Position = [0.2335    0.7048    0.0973    0.1893];
%%
cnt = 1;
for i = length(listFlyNum):-1:1
    if isempty(listFlyNum{i})
        continue
    end
    c3 = 300;
    a2 = scatter(listFlyNum{i}(2:end,1),listFlyNum{i}(2:end,2));hold on;
    a2.MarkerFaceColor = pcaColorStore(cnt,:);
    a2.MarkerEdgeColor = [0 0 0];
    a2.MarkerFaceAlpha = 0.5;
    a2.SizeData = c3;
    temp = listFlyNum{i};
    for ii = 1:length(temp(:,1))
        for iii = 1:length(temp(:,1))
            if ii ~= iii
            a3 = plot([temp(ii,1),temp(iii,1)],[temp(ii,2),temp(iii,2)]);
            a3.LineWidth = 1;a3.Color = pcaColorStore(cnt,:);
            end
        end
    end
    if i == 1 | i == 2 | i == 3
       a2.MarkerEdgeColor = [0 0 0];
       a2.SizeData = 500;
       a2.LineWidth = 2;
       if i == 1
       a2.Marker = 'd';
       elseif i == 2
           a2.Marker = 'p';
       elseif i == 3
           a2.Marker = 's';
       end
       a2.MarkerFaceAlpha = 1;
    end
    cnt = cnt+1;
end
%%
benFigureFormat_gen
pcaPercent = latent/sum(latent)*100;
a = xlabel(strcat('PC 1','(',num2str(round(pcaPercent(1),2)),'%',')'));a.Position(2) = a.Position(2)-0.15;
a = ylabel(strcat('PC 2','(',num2str(round(pcaPercent(2)),2),'%',')'));a.Position(1) = a.Position(1)-0.15;
title('Responses to MCH')
%%
cnt = 1;
MCHOCTifly{1,1} = 'FlyID';MCHOCTifly{1,2} = 'OCT';MCHOCTifly{1,3} = 'MCH';
for i = find(~amw)
    ind = flyNumC == i & ~mchKeyC;
    MCHOCTfly(cnt).OCT = controlOut(ind,:);
    MCHOCTifly{cnt+1,2} = controlOut(ind,:);
    ind = flyNumC == i & mchKeyC;
    MCHOCTfly(cnt).MCH = controlOut(ind,:);
    MCHOCTifly{cnt+1,3} = controlOut(ind,:);
    tempN = strcat({'Fly '},num2str(cnt));tempN = tempN{1};
    MCHOCTifly{cnt+1,1} = tempN;
    cnt = cnt+1;
end
MCHOCTiflyControl = MCHOCTifly;

benDistCalc_fig2g_gen
